-- HivemindLetters - Released during BFA

local HivemindLetters, QuestData = ...

HivemindLetters = LibStub("AceAddon-3.0"):NewAddon("HivemindLetters", "AceConsole-3.0", "AceEvent-3.0")

local fQuestNum = ""
local fQuestName = ""
local fQuestId = ""
local fQuestFound = ""
local optionsFrame = ""
local fDetailsText = ""
local fNotEquiped = "|cffffff00|Hitem:27944::::::::::::|h[Talisman of True Treasure Tracking]|cFFFF0000 Not Equiped!|h|r"
local fEquiped = "|cffffff00|Hitem:27944::::::::::::|h[Talisman of True Treasure Tracking]|cFF00FF00 Is Equiped!|h|r"

HivemindLetters.fLetters = {
	[0] = "Letter 1",
	[1] = "Letter 2",
	[2] = "Letter 3",
	[3] = "Letter 4",
	[4] = "Letter 5",
	[5] = "Letter 6",
	[6] = "Letter 7",
	[7] = "Gift",
}

HivemindLetters.fLocations = {
	[0] = "/way Shattrath City:Outland 65.6 69.3 Griftah",
	[1] = "/way Highmountain:Broken Isles 57.4 27.9 Second Letter",
	[2] = "/way Deadwind Pass 47.0, 69.9 Karazhan",
	[3] = "/way Thousand Needles 45.7 24.0 Razorfen Downs Entrance",
	[4] = "/way Mount Hyjal 44.3 47.3 Entrance to room with Fifth Letter",
	[5] = "/way Icecrown 70.8 73.3 Sixth Letter",
	[6] = "/way Townlong Steppes 37.7 63.0 Seventh Letter",
	[7] = "/way Borean Tundra 27.6 27.1 Gift of Ms. Graham",
}

HivemindLetters.fReport = {
	[0] = "Shattrath City:Outland Griftah Wapoint added!",
	[1] = "Highmountain:Broken Isles Wapoint added!",
	[2] = "Deadwind Pass Karazhan Wapoint added!",
	[3] = "Thousand Needles Razorfen Downs Wapoint added!",
	[4] = "Mount Hyjal Wapoint added!",
	[5] = "Icecrown Wapoint added!",
	[6] = "Townlong Steppes Wapoint added!",
	[7] = "Borean Tundra Wapoint added!",
}

local MyMinimap = {
        type = "launcher",
        text = "HivemindLetters",
        icon = "Interface\\Addons\\HivemindLetters\\Icons\\Hivemind",
        OnClick = function( f, button )
                    --if button == "RightButton" then 
                      LibStub("AceConfigDialog-3.0"):Open("HivemindLetters")
					  HivemindLetters:OnFill()
                    --end
                    GameTooltip:Hide()
                  end,
        OnTooltipShow = function( mt )
                          mt:AddDoubleLine( "HivemindLetters", Minimap.text )
                          mt:AddLine( "|cFFFFFFFFClick to open the the HivemindLetters interface.|r" )
                        end,
} 

HivemindLetters:RegisterChatCommand("mychat", "ChatCommand")

-- Show the GUI if no input is supplied, otherwise handle the chat input.
function HivemindLetters:ChatCommand(input)
  -- Assuming "MyOptions" is the appName of a valid options table
  if not input or input:trim() == "" then
    LibStub("AceConfigDialog-3.0"):Open("options")
  else
    LibStub("AceConfigCmd-3.0").HandleCommand(HivemindLetters, "mychat", "options", input)
  end
end


function RunSlashCmd(cmd)
	local slash, rest = cmd:match("^(%S+)%s*(.-)$")
	ChatFrame_ImportAllListsToHash()
	local handler = hash_SlashCmdList[slash:upper()]
	if handler then
		handler(rest)
	end
end

function HivemindLetters:GetSelVal(info)
	return self.DB.profile.minimap.seltest
end

function HivemindLetters:SetSelVal(info , newValue)
	self.DB.profile.minimap.seltest = newValue
	self:Print(HivemindLetters.fReport[self.DB.profile.minimap.seltest])
	RunSlashCmd(self.fLocations[self.DB.profile.minimap.seltest])
	fDetailsText = HivemindLetters.fReport[self.DB.profile.minimap.seltest]
	LibStub("LibDBIcon-1.0"):Refresh( "HivemindLetters", self.DB.profile.minimap )
end

function HivemindLetters:ResetWay()
	RunSlashCmd("/way reset all")
end

function HivemindLetters:GetOptions()
  local options = {
    name = "HivemindLetters",
    handler = HivemindLetters,
    type = 'group',
    args = {
	    intro = {
		    order = 1,
			  type = "description",
			  name = "HivemindLetters will tell you if you have completed a letter quest and details where to get them.",
		  },
      qf = {
        order = 2,
        type = "input",
        name = "Letters",
        desc = "A list of the quests status",
        usage = "List of quests and completion status.",
        get = "GetQuestFound",
        set = "SetQuestFound",
        width = "full",
        multiline = 7,
		disabled = true,
      },
	  ne = {
        order = 3,
        type = "input",
        name = "Talisman Equiped?",
        --desc = "Talisman of True Treasure Tracking is equiped?",
        --usage = "Check if the Talisman of True Treasure Tracking is equiped.",
        get = "IsTalismanEquip",
        --set = "SetQuestFound",
        width = "full",
        multiline = false,
		disabled = true,
      },
	  ct = {
		order = 4,
		type = "description",
		name = "Press refresh once you get a new letter!",
	  },
	  cl = {
        order = 5,
        type = "select",
        name = "TomTom coords",
        desc = "Click to set tomtom coord",
		values = self.fLetters,
		get = "GetSelVal",
        set = "SetSelVal",
      },
	  rw = {
		order = 6,
        type = "execute",
        name = "Refresh",
		desc = "Refresh Quest Status.",
		func = 'OnFill',
      },
	  ri = {
		order = 7,
        type = "execute",
        name = "Reset Waypoints",
		desc = "Remove all Waypoints",
		func = 'ResetWay',
      },
	  sd = {
		order = 8,
        type = "execute",
        name = "Show Details",
		desc = "Show the details where the selected letter is.",
		func = 'LetterNum'
      },
      mm = {
		order = 9,
        type = "toggle",
        name = "Hide Minimap Icon",
        desc = "If checked, the minimap icon will be hidden.",
        get = 'GetOption',
        set = 'SetOption',
      },
    },
  }
  return options
end

function HivemindLetters:LetterNum()
	if self.DB.profile.minimap.seltest == 0 then
		HivemindLetters:ShowLetterOne()
	elseif self.DB.profile.minimap.seltest == 1 then
		HivemindLetters:ShowLetterTwo()
	elseif self.DB.profile.minimap.seltest == 2 then
		HivemindLetters:ShowLetterTree()
	elseif self.DB.profile.minimap.seltest == 3 then
		HivemindLetters:ShowLetterFour()
	elseif self.DB.profile.minimap.seltest == 4 then
		HivemindLetters:ShowLetterFive()
	elseif self.DB.profile.minimap.seltest == 5 then
		HivemindLetters:ShowLetterSix()
	elseif self.DB.profile.minimap.seltest == 6 then
		HivemindLetters:ShowLetterSeven()
	elseif self.DB.profile.minimap.seltest == 7 then
		HivemindLetters:ShowGift()
	end
end

function HivemindLetters:print_table(node)
    local function tab(amt)
        local str = ""
        for i=1,amt do
            str = str .. "\t"
        end
        return str
    end

    local cache, stack, output = {},{},{}
    local depth = 1
    local output_str = "{\n"

    while true do
        local size = 0
        for k,v in pairs(node) do
            size = size + 1
        end

        local cur_index = 1
        for k,v in pairs(node) do
            if (cache[node] == nil) or (cur_index >= cache[node]) then

                if (string.find(output_str,"}",output_str:len())) then
                    output_str = output_str .. ",\n"
                elseif not (string.find(output_str,"\n",output_str:len())) then
                    output_str = output_str .. "\n"
                end

                table.insert(output,output_str)
                output_str = ""

                local key
                if (type(k) == "number" or type(k) == "boolean") then
                    key = "["..tostring(k).."]"
                else
                    key = "['"..tostring(k).."']"
                end

                if (type(v) == "number" or type(v) == "boolean") then
                    output_str = output_str .. tab(depth) .. key .. " = "..tostring(v)
                    print(k,v)
                elseif (type(v) == "table") then
                    output_str = output_str .. tab(depth) .. key .. " = {\n"
                    table.insert(stack,node)
                    table.insert(stack,v)
                    cache[node] = cur_index+1
                    break
                else
                    output_str = output_str .. tab(depth) .. key .. " = '"..tostring(v).."'"
                end

                if (cur_index == size) then
                    output_str = output_str .. "\n" .. tab(depth-1) .. "}"
                else
                    output_str = output_str .. ","
                end
            else
                -- close the table
                if (cur_index == size) then
                    output_str = output_str .. "\n" .. tab(depth-1) .. "}"
                end
            end

            cur_index = cur_index + 1
        end

        if (size == 0) then
            output_str = output_str .. "\n" .. tab(depth-1) .. "}"
        end

        if (#stack > 0) then
            node = stack[#stack]
            stack[#stack] = nil
            depth = cache[node] == nil and depth + 1 or depth - 1
        else
            break
        end
    end
	
    table.insert(output,output_str)
    output_str = table.concat(output)

end

function HivemindLetters:dump(obj) 
  if type(obj) == 'table' then
    local s = '{'
    for k,v in pairs(obj) do
      if type(k) == 'number' then k = '"'..k..'"' end
      s = s .. '['..k..'] = ' .. HivemindLetters:dump(v) .. ','
    end
    return s .. '}'
  else
    return tostring(obj)
  end
end

StaticPopupDialogs["SHATTRATH_LOCATION"] = {
  text = "Shattrath City is located in Outland. You need to get a |cffffff00|Hitem:27944::::::::::::|h[Talisman of True Treasure Tracking]|h|r from Griftah. Very important, since you must wear it to see and interact with many objects in this guide. Once you get the Talisman, equip it and then click on the Letter from Ms. Graham right side of the table behind Griftah. Click Refresh button to see if the quest is completed.",
  button1 = "Close",
  OnAccept = function()
      --Do something
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}

function HivemindLetters:ShowLetterOne()
	StaticPopup_Show("SHATTRATH_LOCATION")
end

StaticPopupDialogs["LETTERTWO_LOCATION"] = {
  text = "Highmountain is located in Legion, the second letter is located in one of the tents at the Prepfoot Compound on a wooden box where the TomTom location is. To interact with this letter, you MUST have completed letter1.",
  button1 = "Close",
  OnAccept = function()
      --Do something
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}

function HivemindLetters:ShowLetterTwo()
	StaticPopup_Show("LETTERTWO_LOCATION")
end

StaticPopupDialogs["LETTERTREE_LOCATION"] = {
  text = "Karazhan is located in Deadwind Pass southern Eastern Kingdoms, the third letter is located in Medivh's Chambers, located after the Chess Event, in the staircase leading to Prince Malchezaar. The letter is on the chair Medivh used to write his scrolls and spells, literally the seat of the guardian. To interact with this letter, you MUST have letter1 and 2.",
  button1 = "Close",
  OnAccept = function()
      --Do something
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}

function HivemindLetters:ShowLetterTree()
	StaticPopup_Show("LETTERTREE_LOCATION")
end

StaticPopupDialogs["LETTERFOUR_LOCATION"] = {
  text = "Razorfen Downs is located in Thousand Needles in Kalimdor. The letter is located on a hay box behind the last boss, Death Speaker Blackthorn. To interact with this letter, you MUST have interacted with the previous letters",
  button1 = "Close",
  OnAccept = function()
      --Do something
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}

function HivemindLetters:ShowLetterFour()
	StaticPopup_Show("LETTERFOUR_LOCATION")
end

StaticPopupDialogs["LETTERFIVE_LOCATION"] = {
  text = "Mount Hyjal is located in Kalimdor. The letter is at the Shrine of Aviana on a table at the highest floor of the tree that serves as her shrine. To interact with this letter, you MUST have interacted with the previous letters.",
  button1 = "Close",
  OnAccept = function()
      --Do something
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}

function HivemindLetters:ShowLetterFive()
	StaticPopup_Show("LETTERFIVE_LOCATION")
end

StaticPopupDialogs["LETTERSIX_LOCATION"] = {
  text = "Icecrown is located in Northrend. The letter is on a spike of the structure where the TomTom location is. To interact with this letter, you MUST have interacted with the previous letters.",
  button1 = "Close",
  OnAccept = function()
      --Do something
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}

function HivemindLetters:ShowLetterSix()
	StaticPopup_Show("LETTERSIX_LOCATION")
end

StaticPopupDialogs["LETTERSEVEN_LOCATION"] = {
  text = "Townlong Steppes is located in Pandaria. The letter is located at Niuzao Temple near a bell on the back part of the temple where the TomTom location is. To interact with this letter, you MUST have interacted with the previous letters.",
  button1 = "Close",
  OnAccept = function()
      --Do something
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}

function HivemindLetters:ShowLetterSeven()
	StaticPopup_Show("LETTERSEVEN_LOCATION")
end

StaticPopupDialogs["GIFT_LOCATION"] = {
  text = "Ms. Graham give us the last gift, located atop the highest Nexus ring in Coldarra, Borean Tundra in Northrend. The Blue Crystal Monocle is finally ours! To interact with the gift, you MUST have Completed all letters quests.",
  button1 = "Close",
  OnAccept = function()
      --Do something
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}

function HivemindLetters:ShowGift()
	StaticPopup_Show("GIFT_LOCATION")
end

function HivemindLetters:SetOption( info, input)
    self.DB.profile.minimap.hide = input
    LibStub("LibDBIcon-1.0"):Refresh( "HivemindLetters", self.DB.profile.minimap )
end
  
function HivemindLetters:GetOption( info)
    return self.DB.profile.minimap.hide            
end

function HivemindLetters:ClearVars(info)
    fQuestName = ""
    fQuestId = ""
    fQuestFound = ""
	fQuestNum = ""
end

function HivemindLetters:IsTalismanEquip(info)
	if IsEquippedItem(27944) then
		return fEquiped
	else
		return fNotEquiped
	end
end

function HivemindLetters:GetQuestFound(info)
    return fQuestFound
end

function HivemindLetters:SetQuestFound(info, newValue)
    fQuestFound = ""
end

function HivemindLetters:GetQuestId(info)
    return fQuestId
end

function HivemindLetters:SetQuestId(info, newValue, num, QName)
    fQuestId = newValue
	fQuestNum = num
	fQuestName = QName
	
    isCompleted = IsQuestFlaggedCompleted(fQuestId)
    if isCompleted and fQuestId ~= 50181 then 
        fQuestFound = fQuestFound .. "|cFF00FF00 You have completed letter " .. fQuestNum .. " : " .. fQuestName .. "|r\n"
    elseif isCompleted == false and fQuestId ~= 50181 then
        fQuestFound = fQuestFound .. "|cFFFF0000 You have not done letter " .. fQuestNum .. " : " .. fQuestName .. "|r\n"
	elseif isCompleted and fQuestId == 50181 then
		fQuestFound = fQuestFound .. "|cFF00FF00 You have completed " .. fQuestNum .. " : " .. fQuestName .. "|r\n"
	elseif isCompleted == false and fQuestId == 50181 then
		fQuestFound = fQuestFound .. "|cFFFF0000 You have not done " .. fQuestNum .. " : " .. fQuestName .. "|r\n"
    end
end

function HivemindLetters:GetDefaults()
  local defaults = {
    profile = {
      minimap = { 
        hide = true,
      }
    },
  }  
  return defaults
end

-- Not using 
function HivemindLetters:TotalRefresh()
    LibStub("LibDBIcon-1.0"):Refresh( "HivemindLetters", self.DB.profile.minimap )    
end

function HivemindLetters:OnFill()
	HivemindLetters:ClearVars()
	HivemindLetters:SetQuestId(info,40397,1,"Shattrath")
	HivemindLetters:SetQuestId(info,40314,2,"Highmountain")
	HivemindLetters:SetQuestId(info,40404,3,"Karazhan")
	HivemindLetters:SetQuestId(info,40252,4,"Razorfen Downs")
	HivemindLetters:SetQuestId(info,40293,5,"Shrine of Aviana, Mount Hyjal")
	HivemindLetters:SetQuestId(info,40288,6,"Ironwall Dam, between Crystalsong and Icecrown")
	HivemindLetters:SetQuestId(info,50187,7,"Niuzao Temple, Townlong Steppes")
	HivemindLetters:SetQuestId(info,50181,"Gift", "Ms. Graham - Coldarra, Borean Tundra")
end

function HivemindLetters:OnInitialize()
    -- Called when the addon is loaded
    self.DB = LibStub( "AceDB-3.0" ):New( "HivemindLettersDB", self:GetDefaults() )

    self.Options = HivemindLetters:GetOptions()
	
	C_Timer.After(3, function()
	HivemindLetters:OnFill()
	end)
	
	--HivemindLetters.RegisterCallback(self, "Quest_Complete")
	--LibStub("CallbackHandler-1.0"):New(Quest_Complete, "RegisterEvent", "UnregisterEvent", "UnregisterAllEvents")
	--LibStub("CallbackHandler-1.0"):New(Quest_Complete, RegisterName, UnregisterName, UnregisterAllName)
	
    LibStub("AceConfig-3.0"):RegisterOptionsTable("HivemindLetters", self.Options, {"hl"})
    LibStub("AceConfigDialog-3.0"):SetDefaultSize("HivemindLetters", 490, 400)
    optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("HivemindLetters", "HivemindLetters")
    self:RegisterChatCommand("hl", function() LibStub("AceConfigDialog-3.0"):Open("HivemindLetters") end)
    
    LibStub("LibDataBroker-1.1"):NewDataObject("HivemindLetters", MyMinimap);
    LibStub("LibDBIcon-1.0"):Register("HivemindLetters", MyMinimap, self.DB);
end

function HivemindLetters:ChatCommand(input)
   if not input or input:trim() == "" then
       InterfaceOptionsFrame_OpenToCategory(optionsFrame)
   else     
        LibStub("AceConfigCmd-3.0"):HandleCommand("hl", input)
   end
end

function HivemindLetters:OnEnable()
    -- Called when the addon is enabled
    if self.DB.profile.minimap.hide == true then
      self:Print("HivemindLetters enabled.  Minimap Icon is hidden.")
    else
      self:Print("HivemindLetters enabled.  Minimap Icon is shown.")
    end
    LibStub("LibDBIcon-1.0"):Refresh( "HivemindLetters", self.DB.profile.minimap )
end

function HivemindLetters:OnDisable()
    -- Called when the addon is disabled
    self:Print("HivemindLetters disabled.")
end

C_Timer.After(3, function() DEFAULT_CHAT_FRAME:AddMessage("|cff0083e8<HivemindLetters loaded!>|cffffff3aType /hl to open addon!|r") end)
